<link href="css/example13.css" rel="stylesheet" type="text/css" />

<script type="text/javascript" src="js/jquery-ui-1.7.1.custom.min.js"></script>

<cfparam name="form.myname" default=""/>
<cfparam name="form.email" default=""/>
<cfparam name="form.age" default=""/>	
<cfparam name="form.creditcard" default="5454-5454-5454-5454"/>	

<script type="text/javascript" id="example">
$(document).ready(function() {

	$('.billing').hide(); //hide billing form until we need it	
	$('.receipt').hide(); //hide receipt page until we need it	

//Get Products from CFC with JSON call
$.getJSON('/jQueryDemo/components/DataFeed.cfc?method=getproducts&returnFormat=json&queryFormat=column', function(data){
	$('.products').empty();

	for(var i=0;i < data.ROWCOUNT; i++){			
		var html = '<div id="'+data.DATA.sku[i]+'" class="ui-widget">';
		html += '<p>'+data.DATA.name[i]+' - $'+data.DATA.price[i]+'</p>';
		html += '<img width="40" hspace="15" src="'+data.DATA.image[i]+'"/>';
		html += '</div>';
		$('.products').append(html);
	};		
	$(".ui-widget").draggable();	//Set these newly imported products as draggable
});

//Do a few things when we drop items to our cart
$('#myCart').droppable({
	drop: function(event, ui) {
		var currentText = "<br/>"+ui.draggable.find('p').text();

		//alert(ui.draggable.attr('id'));
		//we could do a simple .get call back to ColdFusion to let it know that an item was added to the cart

		ui.draggable.remove();
		$(this).addClass('ui-state-highlight').find('p').append(currentText);
	}
});

//Click checkout link
$("#checkout").click(function(){
	$('.products').hide('slow', function() {	//we use the call back option in hide() to then fire off the showing of the billing form
		$('.billing').show('slow');
	});	
});

//Click continue shopping link
$("#continue").click(function(){
	$('.billing').hide('slow', function() {	//we use the call back option in hide() to then fire off the showing of the products form
		$('.products').show('slow');
	});	
});

//Click place order button
$("#placeorder").click(function(){
	var html = '<p><b>My Cart</b> [<a href="##" id="checkout">Checkout!</a>]</p>';  
	$('#myCart').empty().append(html); //Resetting our cart pod

	//alert($('#myname').val()); //just an example of how to get the form data
	//we could at this point do a .post call to tell ColdFusion we're checking out
		
	$('.billing').hide('slow', function() {	//we use the call back option again here
		$('.receipt').show('slow');
	});	
});

//idle and active form fields
	$('input[type="text"]').addClass("idleField");  
	$('.error').hide();  

    $('input[type="text"]').focus(function() {  
         $(this).removeClass().addClass("focusField");  
    });  
    
//validate form entries
    $('input[type="text"]').blur(function() {
    	var fieldData = $(this).val();
    	var fieldName = $(this).attr("name");
    	var errorField = fieldName + "_error";
    	var errorText = '';

	   $.post(
       'example11-checker.cfm',
       {item : fieldName,data : fieldData},
       function(xml){
       		if ($(xml).text() > ''){
    	    	$("input[name='"+fieldName+"']").removeClass().addClass("errorField");
	    		$("label[id='"+errorField+"']").text($(xml).text());
	    		$("label[id='"+errorField+"']").show();
       		}else{
    	    	$("input[name='"+fieldName+"']").removeClass().addClass("idleField");
	    		$("label[id='"+errorField+"']").text('');
	    		$("label[id='"+errorField+"']").hide();
       		}
       });
    });     


});
</script>

Now that we know a few things about jQuery let's combine these cool features to build a very simple shopping cart.
<div class="cart-page">

<div class="products"></div>

<div class="billing">
	<p><b>Billing Information</b> - [<a href="##" id="continue">Continue Shopping</a>]<p/>
	<form>
	<cfoutput>	
	<label>My Name:</label> <label id="myname_error" class="error"></label>
	<input id="myname" type="text" name="myname" value="#form.myname#"/>

	<label>Email:</label> <label id="email_error" class="error"></label>
	<input id="email" type="text" name="email" value="#form.email#"/>

	<label>Credit Card:</label> <label id="creditcard_error" class="error"></label>
	<input id="creditcard" type="text" name="creditcard" value="#form.creditcard#"/>
	</cfoutput>
	<input id="placeorder" type="button" value="Place Order"/>
	</form>
</div>

<div class="receipt">
	<p><b>Your order has been placed!</b></p>
	Not really, but this is a really simple example of using jQuery and ColdFusion together to make a fun shopping cart app.
</div>

<div id="myCart" class="ui-widget-drop">
	<p><b>My Cart</b> [<a href="##" id="checkout">Checkout!</a>]</p>
</div>

</div>
